
#define _MAIN

	
#ifdef _MAIN

#include <iostream.h>
#include <stdio.h>
#include <time.h>
#define OTL_BIGINT u_int64_t
#define OTL_ODBC // Compile OTL 4.0/ODBC
#define OTL_ODBC_UNIX
#include "otlv4.h" // include the OTL 4.0 header file

otl_connect db; // connect object


int main()
{
 otl_connect::otl_initialize(); // initialize ODBC environment
 try{

  db.rlogon(getenv ( "DSN" )); // connect to ODBC

//  db.auto_commit_off();

  long rpc  = otl_cursor::direct_exec
   (
    db,
    "insert into testtable ( enddate ) values ( NULL )",
    otl_exception::enabled //  OTL exceptions
   ); 

   if (rpc !=1 ) {
    printf ("Error rpc != 1" );
    exit(-1);
	}
  
   OTL_BIGINT idval;
   otl_stream id;
   id.set_column_type(1,otl_var_bigint );
   id.open ( 50, 
	   "select id from testtable where enddate is null",
	   db);
   id.rewind();
   id>>idval;
   std::cerr << "Value is: " << idval;

   otl_cursor::direct_exec
	(
	db,
	"update testtable set enddate = getdate() where enddate is null ",
	otl_exception::enabled //  OTL exceptions
	); 
 
  db.commit();
 } catch(otl_exception& p){ // intercept OTL exceptions
  cerr<<p.msg<<endl; // print out error message
  cerr<<p.stm_text<<endl; // print out SQL that caused the error
  cerr<<p.sqlstate<<endl; // print out SQLSTATE message
  cerr<<p.var_info<<endl; // print out the variable that caused the error
  db.rollback();
 }


 db.logoff(); 

 return 0;

}





#endif
